(function() {

	var isWin = (navigator.platform == "Win32") || (navigator.platform == "Windows");
	var embedOpenInIE;

	function openInIE(url) {
		var newUrl = url;
		if (embedOpenInIE) {
			if (newUrl) embedOpenInIE.openInIE(newUrl);
			else embedOpenInIE.openInIE(url)
		};
		if (url.indexOf('file://') == 0) url = 'file://';
		else {
			if (url.indexOf('//') != -1) url = url.substr(url.indexOf('//') + 2);
			if (url.indexOf('/') != -1) url = url.substr(0, url.indexOf('/'))
		};
	};
	window.onload = function() {
		embedOpenInIE = document.getElementById("embedOpenInIE");
	};
	
	chrome.contextMenus.create({
      "title":"在IE中打开本页",
      "contexts":["page"],
	  "onclick":function(info,tab){
		  if(tab.url.indexOf("http")==0){
			  openInIE(tab.url);
		  }
		  else alert("很抱歉，网页地址无效"); 
	   }
    });
	chrome.contextMenus.create({
      "title":"在IE中打开链接",
      "contexts":["link"],
	  "onclick":function(clickInfo){
		
		  if(clickInfo.linkUrl.indexOf("http")==0){
			  openInIE(clickInfo.linkUrl);
		  }
		  else alert("很抱歉，链接地址无效"); 
		  
	   }
    });
	
})();