var domains = [];

function recommend_website(d) {
    if (!domains[getHostname(d.url)] && d.url.indexOf("http://") != "0" && d.url.indexOf("https://") != "0") {
        return
    }
    if (!d.image && suggestThumbnail(d.url) == "") {
        return
    }
    if (!d.image) {
        d.image = suggestThumbnail(d.url)
    }
    domains.push(getHostname(d.url));
    var a = document.createElement("label");
    var c = document.createElement("a");
    var e = document.createElement("input");
    var b = document.createElement("div");
    e.setAttribute("type", "checkbox");
    e.setAttribute("url", d.url);
    e.setAttribute("title", d.title);
    e.setAttribute("thumbnail", d.image);
    b.style.backgroundImage = "url(" + d.image + ")";
    b.setAttribute("class", "favicon");
    c.innerHTML = d.title;
    a.setAttribute("class", "website");
    a.appendChild(b);
    a.appendChild(e);
    a.appendChild(c);
    $("#most_visited_websites").append(a)
}

function calcTrends() {
    domains = [];
    chrome.topSites.get(function(d) {
        var b = 12;
        for (var a = 0; a < d.length; ++a) {
            var c = d[a];
            recommend_website(c)
        }
        var a = 0;
        while (domains.length < b) {
            var c = topSites[a];
            recommend_website(c);
            a++
        }
    })
}
$(function() {
    background_init();
    welcome(1)
});

function welcome(a) {
    if (a > 1) {
        localStorage.firstTime = "false"
    }
    /*if (a == 2) {
        _gaq.push(["_trackEvent", "Extension", "Started extension tour"])
    }*/
    $(".welcome").hide();
    $("#welcome-" + a).show();
    if (a == 10) {
        $("#most_visited_websites").html("");
        calcTrends()
    }
}

function finish() {
    var a = 0;
    var b = $("#most_visited_websites input:checked").size();
    var c = 0;
    //_gaq.push(["_trackEvent", "Extension", "Finished extension tour"]);
    if (b > 0) {
        $("#most_visited_websites input:checked").each(function() {
            a++;
            var d = $(this);
            insert = new Array();
            insert.url = d.attr("url");
            insert.title = d.attr("title");
            insert.thumbnail = d.attr("thumbnail");
            insert.ts_created = Math.round(new Date().getTime() / 1000);
            insert.visits = 0;
            insert.visits_morning = 0;
            insert.visits_afternoon = 0;
            insert.visits_evening = 0;
            insert.visits_night = 0;
            insert.position = a;
            insert.idgroup = 0;
            speeddial.storage.addItem(insert, function() {
                c++;
                if (c == b) {
                    top.location.href = chrome.extension.getURL("newtab.html")
                }
            })
        })
    } else {
        top.location.href = chrome.extension.getURL("newtab.html")
    }
}

function suggestThumbnail(a) {
    suggest = { };
    for (var b in suggest) {
        if (a.indexOf(suggest[b]) > -1) {
            return b
        }
    }
    return ""
}
$(function() {
    $("*[i18n]").each(function() {
        if (i18n($(this).attr("i18n"))) {
            $(this).html(i18n($(this).attr("i18n")))
        }
    })
});
$(function() {
    $(".click-open-extension-page").click(function() {
        top.location.href = chrome.extension.getURL($(this).data("url"))
    });
    $(document).bind("change", "input[type=checkbox]", function(a) {
        if (a.target.checked) {
            $(a.target).parents(".website").addClass("selected")
        } else {
            $(a.target).parents(".website").removeClass("selected")
        }
    });
    $(".click-welcome").click(function() {
        welcome($(this).data("screen"))
    });
    $(".click-import-selected").click(function() {
        finish()
    })
});

var topSites = [{
    url: "http://www.baidu.com",
    image: "http://p5.qhimg.com/t01676df94abacb529a.png",
    title: "百度"
}, {
    url: "http://www.qq.com",
    image: "http://p3.qhimg.com/t015c6121856f79784e.png",
    title: "腾讯网"
}, {
    url: "http://www.taobao.com",
    image: "http://p0.qhimg.com/t0161d150b8870f30fb.png",
    title: "淘宝网"
}, {
    url: "http://www.163.com",
    image: "http://p8.qhimg.com/t016833b22727e72ada.png",
    title: "网易"
}, {
    url: "http://weibo.com",
    image: "http://p1.qhimg.com/t01e65993bce30c1d9a.png",
    title: "新浪微博"
}, {
    url: "http://www.sohu.com",
    image: "http://p8.qhimg.com/t018805bc806d7b829b.png",
    title: "搜狐网"
}, {
    url: "http://www.jd.com",
    image: "http://p0.qhimg.com/t01904be87992e26baa.png",
    title: "京东商城"
}, {
    url: "http://www.ifeng.com",
    image: "http://p7.qhimg.com/t012c9a5469aaf7a9b2.png",
    title: "凤凰网"
}, {
    url: "http://qzone.qq.com",
    image: "http://p7.qhimg.com/t0186ec7dbad8dea9d5.png",
    title: "QQ空间"
}, {
    url: "https://www.haosou.com",
    image: "http://p5.qhimg.com/t011819420840a9dfd1.png",
    title: "好搜"
}, {
    url: "http://www.youku.com",
    image: "http://p0.qhimg.com/t01ccabe8e459d12e91.png",
    title: "优酷网"
}, {
    url: "http://tieba.baidu.com",
    image: "http://p2.qhimg.com/t0160370f992bf18a7f.png",
    title: "百度贴吧"
}, {
    url: "http://www.sina.com.cn",
    image: "http://p3.qhimg.com/t019c762c2d716af231.png",
    title: "新浪网"
}];