var b = chrome.extension.getBackgroundPage();
Array.prototype.diff = function(c) {
    return this.filter(function(a) {
        return !(c.indexOf(a) > -1)
    })
};
Array.prototype.toObject = function() {
    var c = {};
    for (var a = 0; a < this.length; ++a) {
        if (this[a] !== undefined) {
            c[a] = this[a]
        }
    }
    return c
};
Object.size = function(d) {
    var c = 0,
        a;
    for (a in d) {
        if (d.hasOwnProperty(a)) {
            c++
        }
    }
    return c
};

function isNumber(a) {
    return typeof a === "number" && isFinite(a)
}

function getHostname(a) {
    if (typeof a != "undefined" && a.indexOf("chrome-extension") < 0 && a.indexOf("http") > -1) {
        return a.split(/\/+/g)[1]
    } else {
        return
    }
}

function validateUrl(a) {
    var c = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
    return c.test(a)
}

function validateEmail(a) {
    var c = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    return c.test(a)
}

function strstr(c, d, a) {
    var e = 0;
    c += "";
    e = c.indexOf(d);
    if (e == -1) {
        return false
    } else {
        if (a) {
            return c.substr(0, e)
        } else {
            return c.slice(e)
        }
    }
}

function loadScript(c) {
    if ($('script[src="' + c + '"]').length == 0) {
        var a = document.createElement("script");
        a.type = "text/javascript";
        a.src = c;
        document.body.appendChild(a);
        console.log("script " + c + " loaded dynamically")
    }
}

function prettyDate(e) {
    var c = new Date(1000 * e),
        d = (((new Date()).getTime() - c.getTime()) / 1000),
        a = Math.floor(d / 86400);
    if (isNaN(a) || a < 0 || a >= 31) {
        return
    }
    return a == 0 && (d < 60 && "just now" || d < 120 && "1 minute ago" || d < 3600 && Math.floor(d / 60) + " minutes ago" || d < 7200 && "1 hour ago" || d < 86400 && Math.floor(d / 3600) + " hours ago") || a == 1 && "Yesterday" || a < 7 && a + " days ago" || a < 31 && Math.ceil(a / 7) + " weeks ago"
}

function safestr(a) {
    if (jQuery !== undefined) {
        return jQuery("<div/>").text(a).html()
    }
    return a.replace(/&/g, "&amp;").replace(/>/g, "&gt;").replace(/</g, "&lt;").replace(/"/g, "&quot;")
};