var themeOptions = [{
    url: "images/themes/mountains/background.png",
    pattern: "",
    preview: "images/themes/mountains/background.png",
    color: "#bfd9d9",
    name: "Mountains",
    position: "center bottom",
    repeat: "repeat-x",
    size: "contain",
    customizable: 1,
    type: "theme",
}, {
    url: "http://i.imgur.com/jxd7hCK.png",
    pattern: "",
    preview: "http://i.imgur.com/jxd7hCK.png",
    color: "#8bacbf",
    name: "Workspace",
    position: "center",
    repeat: "no-repeat",
    size: "contain",
    customizable: 1,
    type: "theme"
}, {
    url: "http://i.imgur.com/bAS5g0D.png",
    pattern: "",
    preview: "http://i.imgur.com/bAS5g0D.png",
    color: "#555e7b",
    name: "Forrest by <a href='http://dribbble.com/virae' target='_blank'>virae</a>",
    position: "center bottom",
    repeat: "no-repeat",
    size: "contain",
    customizable: 1,
    type: "theme"
}, {
    url: "http://i.imgur.com/rlSENdZ.png",
    pattern: "",
    preview: "http://i.imgur.com/rlSENdZ.png",
    color: "#d2f2f7",
    name: "Fox by <a href='http://www.lenkasukenikova.sk' target='_blank'>Lenka Sukenikova</a>",
    position: "right bottom",
    repeat: "no-repeat",
    size: "contain",
    customizable: 1,
    type: "theme"
}, {
    url: "http://i.imgur.com/RLU5xo9.png",
    pattern: "",
    preview: "http://i.imgur.com/RLU5xo9.png",
    color: "#c2bfbe",
    name: "Bonds by <a target='_blank' Href='http://dragonlivia.blogspot.cz/'>Lívia Mezovská</a>",
    position: "center bottom",
    repeat: "no-repeat",
    size: "1380px",
    customizable: 1,
    type: "theme"
}, {
    url: "images/themes/light/background_top.jpg",
    pattern: "images/themes/light/background_strip.jpg",
    preview: "images/themes/light/preview.jpg",
    color: "#fff",
    name: "Speed Dial 2 by <a href='http://dribbble.com/virae' target='_blank'>virae</a>",
    position: "right top",
    repeat: "repeat-x",
    size: "contain",
    type: "theme"
}, {
    url: "http://i.imgur.com/BFv7RYs.png",
    pattern: "",
    preview: "http://i.imgur.com/BFv7RYs.png",
    color: "#273464",
    name: "Space",
    position: "center bottom",
    repeat: "no-repeat",
    size: "contain",
    type: "theme"
}, {
    url: "http://i.imgur.com/QSTAPVw.png",
    pattern: "",
    preview: "http://i.imgur.com/QSTAPVw.png",
    color: "#c7dbe0",
    name: "Paper clip",
    position: "center bottom",
    repeat: "repeat",
    size: "457px",
    customizable: 1,
    type: "theme"
}, {
    url: "http://i.imgur.com/5tMNlyw.jpg",
    pattern: "",
    preview: "http://i.imgur.com/5tMNlyw.jpg",
    color: "#f0efec",
    name: "Alchemy by <a target='_blank' Href='https://twitter.com/repponen'>Anton Repponen</a>",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "theme"
}, {
    url: "http://i.imgur.com/sAxCyHx.png",
    pattern: "",
    preview: "http://i.imgur.com/sAxCyHx.png",
    color: "#e64600",
    name: "Hodgepodge by <a target='_blank' Href='http://agromov.com/'>Anatoliy Gromov</a>",
    position: "left top",
    repeat: "repeat",
    size: "original",
    type: "theme"
}, {
    url: "http://i.imgur.com/am2vjWY.png",
    pattern: "",
    preview: "http://i.imgur.com/am2vjWY.png",
    color: "#f1ede6",
    name: "Subway Lines by <a target='_blank' href='http://twitter.com/marcbanderson'>Marc Anderson</a>",
    position: "left top",
    repeat: "repeat",
    size: "original",
    type: "theme"
}, {
    url: "http://i.imgur.com/ZUIQdPE.png",
    pattern: "",
    preview: "http://i.imgur.com/ZUIQdPE.png",
    color: "#000000",
    name: "Retro Furnish by <a target='_blank' Href='http://twitter.com/heuryheury'>Heury & Heury</a>",
    position: "left top",
    repeat: "repeat",
    size: "original",
    type: "theme"
}, {
    url: "http://i.imgur.com/kFhc1LQ.jpg",
    pattern: "",
    preview: "http://i.imgur.com/kFhc1LQ.jpg",
    color: "#f1ede6",
    name: "Asteroids <br> by <a target='_blank' href='http://twitter.com/kustkunst'>Sanja Kusturica</a>",
    position: "left top",
    repeat: "repeat",
    size: "original",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/4sR7J7G.png",
    pattern: "",
    preview: "http://i.imgur.com/4sR7J7G.png",
    color: "#3fca90",
    name: "Glitch<br> by <a target='_blank' Href='http://twitter.com/destroywerk'>Tim Green</a>",
    position: "left top",
    repeat: "repeat",
    size: "original",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/vNqdxFs.png",
    pattern: "",
    preview: "http://i.imgur.com/vNqdxFs.png",
    color: "#05062c",
    name: "Magnus 2050<br> by <a target='_blank' Href='http://www.egosmoke.com/'>Kristoffer Brady</a>",
    position: "left top",
    repeat: "repeat",
    size: "original",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/jFIcCLR.png",
    pattern: "",
    preview: "http://i.imgur.com/jFIcCLR.png",
    color: "#eafaff",
    name: "Bunting Flag<br> by <a target='_blank' Href='http://twitter.com/shonencmyk'>Raul Varela</a>",
    position: "left top",
    repeat: "repeat",
    size: "original",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/8NnHszI.png",
    pattern: "",
    preview: "http://i.imgur.com/8NnHszI.png",
    color: "#fff",
    name: "Cuadros<br> by <a target='_blank' Href='http://www.domestika.org/es/natalia_f_ramos/portfolio'>Natalia De Frutos</a>",
    position: "left top",
    repeat: "repeat",
    size: "original",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/cDHfhGp.png",
    pattern: "",
    preview: "",
    color: "#5c82b3",
    name: "",
    position: "left top",
    repeat: "repeat-x",
    size: "original",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/VUTJAyQ.jpg",
    pattern: "",
    preview: "",
    color: "#2fe487",
    name: "",
    position: "left top",
    repeat: "repeat-x",
    size: "original",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/d5YJuaL.jpg",
    pattern: "",
    preview: "",
    color: "#b6344e",
    name: "",
    position: "left top",
    repeat: "repeat-x",
    size: "original",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/Rb2UAR1.jpg",
    pattern: "",
    preview: "",
    color: "#ede9c6",
    name: "",
    position: "left top",
    repeat: "repeat-x",
    size: "original",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/8TVdou5.jpg",
    pattern: "",
    preview: "",
    color: "#e9e7d8",
    name: "",
    position: "left top",
    repeat: "repeat-x",
    size: "original",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/CuTMEuj.png",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern featured"
}, {
    url: "",
    pattern: "http://i.imgur.com/uVt9aoB.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern featured"
}, {
    url: "",
    pattern: "http://i.imgur.com/X8Ty0ZK.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern featured"
}, {
    url: "",
    pattern: "http://i.imgur.com/kmbMZHy.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern featured"
}, {
    url: "http://i.imgur.com/tWQKOpM.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/3kNlnCZ.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/04J81Bc.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/Tl4hNba.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/EbycKq4.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/Qii5Opi.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/lJecBP3.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/F0nZ3iM.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/WO2iAOk.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/4zDwXJc.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/r2i8Sbz.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/AV0WuHp.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/ztyDb8J.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/9NskJaf.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/9GYFgwk.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/q9pZZJo.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/f0XZ9CH.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/15eeACv.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/gBHJGgV.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/b0OAmMr.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/LdAPWDM.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/KHLk14I.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/9e9M12e.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "http://i.imgur.com/zOiFvS2.jpg",
    pattern: "",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "contain",
    type: "pattern tile"
}, {
    url: "",
    pattern: "http://i.imgur.com/2Bf833l.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/TVB7kRU.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/W32eCrE.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/eF4SIYu.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/MyNq9ef.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/ij2PSwG.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/DD3F8ff.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/PnIDVDw.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/IACn4wz.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/g08W572.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/pGwOe4F.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/Rdoq8mp.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/Zsv2STv.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/WYniCoq.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/3CfNNlM.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/uy1jPu8.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/MdUHorN.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/6NA69Tu.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/fK4Ahxs.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/d9aNZFs.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/ofRZBSo.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/5eHEbjR.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/ugLAL86.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/EDWWfPa.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/jQSpqyw.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/x7iDQJE.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/GipyFx2.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/qgcObPz.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/ptcLGqF.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/XB4h5b2.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/SCHHzuv.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/RTN3NWa.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/bFR7eXp.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/O27uKhe.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/GlM33F9.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/lpSdBw5.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/sMmLA1i.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/SVHobBn.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/ycVdZPr.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}, {
    url: "",
    pattern: "http://i.imgur.com/qKev92w.png",
    preview: "",
    color: "",
    name: "",
    position: "left top",
    repeat: "repeat",
    size: "auto",
    type: "pattern"
}];